package java.awt;

import java.awt.image.ImageObserver;

class ImageMediaEntry extends MediaEntry implements ImageObserver {
   Image image;
   int width;
   int height;

   ImageMediaEntry(MediaTracker var1, Image var2, int var3, int var4, int var5) {
      super(var1, var3);
      this.image = var2;
      this.width = var4;
      this.height = var5;
   }

   Object getMedia() {
      return this.image;
   }

   void startLoad() {
      if (super.tracker.target.prepareImage(this.image, this.width, this.height, this)) {
         ((MediaEntry)this).setStatus(8);
      }

   }

   public boolean imageUpdate(Image var1, int var2, int var3, int var4, int var5, int var6) {
      if ((var2 & 64) != 0) {
         ((MediaEntry)this).setStatus(4);
      } else if ((var2 & 128) != 0) {
         ((MediaEntry)this).setStatus(2);
      } else if ((var2 & 48) != 0) {
         ((MediaEntry)this).setStatus(8);
      }

      return true;
   }
}
