package java.awt;

import java.awt.peer.MenuBarPeer;
import java.util.Vector;

public class MenuBar extends MenuComponent implements MenuContainer {
   Vector menus = new Vector();
   Menu helpMenu;

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = Toolkit.getDefaultToolkit().createMenuBar(this);
      }

      int var1 = this.countMenus();

      for(int var2 = 0; var2 < var1; ++var2) {
         this.getMenu(var2).addNotify();
      }

   }

   public void removeNotify() {
      int var1 = this.countMenus();

      for(int var2 = 0; var2 < var1; ++var2) {
         this.getMenu(var2).removeNotify();
      }

      super.removeNotify();
   }

   public Menu getHelpMenu() {
      return this.helpMenu;
   }

   public synchronized void setHelpMenu(Menu var1) {
      if (this.helpMenu != null) {
         this.helpMenu.removeNotify();
         this.helpMenu.parent = null;
      }

      this.helpMenu = var1;
      if (var1 != null) {
         var1.isHelpMenu = true;
         MenuBarPeer var2 = (MenuBarPeer)super.peer;
         if (var2 != null) {
            if (var1.peer == null) {
               var1.addNotify();
            }

            var2.addHelpMenu(var1);
         }
      }

   }

   public synchronized Menu add(Menu var1) {
      if (var1.parent != null) {
         var1.parent.remove(var1);
      }

      this.menus.addElement(var1);
      var1.parent = this;
      MenuBarPeer var2 = (MenuBarPeer)super.peer;
      if (var2 != null) {
         if (var1.peer == null) {
            var1.addNotify();
         }

         var2.addMenu(var1);
      }

      return var1;
   }

   public synchronized void remove(int var1) {
      MenuBarPeer var2 = (MenuBarPeer)super.peer;
      if (var2 != null) {
         Menu var3 = this.getMenu(var1);
         var3.removeNotify();
         var3.parent = null;
         var2.delMenu(var1);
      }

      this.menus.removeElementAt(var1);
   }

   public synchronized void remove(MenuComponent var1) {
      int var2 = this.menus.indexOf(var1);
      if (var2 >= 0) {
         this.remove(var2);
      }

   }

   public int countMenus() {
      return this.menus.size();
   }

   public Menu getMenu(int var1) {
      return (Menu)this.menus.elementAt(var1);
   }
}
