package java.awt;

import java.io.Serializable;

public class Rectangle implements Shape, Serializable {
   // $FF: renamed from: x int
   public int field_0;
   // $FF: renamed from: y int
   public int field_1;
   public int width;
   public int height;

   public Rectangle() {
      this(0, 0, 0, 0);
   }

   public Rectangle(Rectangle var1) {
      this(var1.field_0, var1.field_1, var1.width, var1.height);
   }

   public Rectangle(int var1, int var2, int var3, int var4) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.width = var3;
      this.height = var4;
   }

   public Rectangle(int var1, int var2) {
      this(0, 0, var1, var2);
   }

   public Rectangle(Point var1, Dimension var2) {
      this(var1.x, var1.y, var2.width, var2.height);
   }

   public Rectangle(Point var1) {
      this(var1.x, var1.y, 0, 0);
   }

   public Rectangle(Dimension var1) {
      this(0, 0, var1.width, var1.height);
   }

   public Rectangle getBounds() {
      return new Rectangle(this.field_0, this.field_1, this.width, this.height);
   }

   public void setBounds(Rectangle var1) {
      this.setBounds(var1.field_0, var1.field_1, var1.width, var1.height);
   }

   public void setBounds(int var1, int var2, int var3, int var4) {
      this.reshape(var1, var2, var3, var4);
   }

   public void reshape(int var1, int var2, int var3, int var4) {
      this.field_0 = var1;
      this.field_1 = var2;
      this.width = var3;
      this.height = var4;
   }

   public Point getLocation() {
      return new Point(this.field_0, this.field_1);
   }

   public void setLocation(Point var1) {
      this.setLocation(var1.x, var1.y);
   }

   public void setLocation(int var1, int var2) {
      this.move(var1, var2);
   }

   public void move(int var1, int var2) {
      this.field_0 = var1;
      this.field_1 = var2;
   }

   public void translate(int var1, int var2) {
      this.field_0 += var1;
      this.field_1 += var2;
   }

   public Dimension getSize() {
      return new Dimension(this.width, this.height);
   }

   public void setSize(Dimension var1) {
      this.setSize(var1.width, var1.height);
   }

   public void setSize(int var1, int var2) {
      this.resize(var1, var2);
   }

   public void resize(int var1, int var2) {
      this.width = var1;
      this.height = var2;
   }

   public boolean contains(Point var1) {
      return this.contains(var1.x, var1.y);
   }

   public boolean contains(int var1, int var2) {
      return this.inside(var1, var2);
   }

   public boolean inside(int var1, int var2) {
      return var1 >= this.field_0 && var1 - this.field_0 < this.width && var2 >= this.field_1 && var2 - this.field_1 < this.height;
   }

   public boolean intersects(Rectangle var1) {
      return var1.field_0 + var1.width > this.field_0 && var1.field_1 + var1.height > this.field_1 && var1.field_0 < this.field_0 + this.width && var1.field_1 < this.field_1 + this.height;
   }

   public Rectangle intersection(Rectangle var1) {
      int var2 = Math.max(this.field_0, var1.field_0);
      int var3 = Math.min(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.max(this.field_1, var1.field_1);
      int var5 = Math.min(this.field_1 + this.height, var1.field_1 + var1.height);
      return new Rectangle(var2, var4, var3 - var2, var5 - var4);
   }

   public Rectangle union(Rectangle var1) {
      int var2 = Math.min(this.field_0, var1.field_0);
      int var3 = Math.max(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.min(this.field_1, var1.field_1);
      int var5 = Math.max(this.field_1 + this.height, var1.field_1 + var1.height);
      return new Rectangle(var2, var4, var3 - var2, var5 - var4);
   }

   public void add(int var1, int var2) {
      int var3 = Math.min(this.field_0, var1);
      int var4 = Math.max(this.field_0 + this.width, var1);
      int var5 = Math.min(this.field_1, var2);
      int var6 = Math.max(this.field_1 + this.height, var2);
      this.field_0 = var3;
      this.field_1 = var5;
      this.width = var4 - var3;
      this.height = var6 - var5;
   }

   public void add(Point var1) {
      this.add(var1.x, var1.y);
   }

   public void add(Rectangle var1) {
      int var2 = Math.min(this.field_0, var1.field_0);
      int var3 = Math.max(this.field_0 + this.width, var1.field_0 + var1.width);
      int var4 = Math.min(this.field_1, var1.field_1);
      int var5 = Math.max(this.field_1 + this.height, var1.field_1 + var1.height);
      this.field_0 = var2;
      this.field_1 = var4;
      this.width = var3 - var2;
      this.height = var5 - var4;
   }

   public void grow(int var1, int var2) {
      this.field_0 -= var1;
      this.field_1 -= var2;
      this.width += var1 * 2;
      this.height += var2 * 2;
   }

   public boolean isEmpty() {
      return this.width <= 0 || this.height <= 0;
   }

   public int hashCode() {
      return this.field_0 ^ this.field_1 * 37 ^ this.width * 43 ^ this.height * 47;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof Rectangle) {
         Rectangle var2 = (Rectangle)var1;
         return this.field_0 == var2.field_0 && this.field_1 == var2.field_1 && this.width == var2.width && this.height == var2.height;
      } else {
         return false;
      }
   }

   public String toString() {
      return this.getClass().getName() + "[x=" + this.field_0 + ",y=" + this.field_1 + ",width=" + this.width + ",height=" + this.height + "]";
   }
}
