package java.awt;

import java.awt.peer.CheckboxPeer;

public class Checkbox extends Component {
   String label;
   boolean state;
   CheckboxGroup group;

   void setStateInternal(boolean var1) {
      this.state = var1;
      CheckboxPeer var2 = (CheckboxPeer)super.peer;
      if (var2 != null) {
         var2.setState(var1);
      }

   }

   public Checkbox() {
   }

   public Checkbox(String var1) {
      this.label = var1;
   }

   public Checkbox(String var1, CheckboxGroup var2, boolean var3) {
      this.label = var1;
      this.state = var3;
      this.group = var2;
      if (var3 && var2 != null) {
         var2.setCurrent(this);
      }

   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Component)this).getToolkit().createCheckbox(this);
      }

      super.addNotify();
   }

   public String getLabel() {
      return this.label;
   }

   public void setLabel(String var1) {
      this.label = var1;
      CheckboxPeer var2 = (CheckboxPeer)super.peer;
      if (var2 != null) {
         var2.setLabel(var1);
      }

   }

   public boolean getState() {
      return this.state;
   }

   public void setState(boolean var1) {
      CheckboxGroup var2 = this.group;
      if (var2 != null) {
         if (var1) {
            var2.setCurrent(this);
         } else if (var2.getCurrent() == this) {
            var1 = true;
         }
      }

      this.setStateInternal(var1);
   }

   public CheckboxGroup getCheckboxGroup() {
      return this.group;
   }

   public void setCheckboxGroup(CheckboxGroup var1) {
      CheckboxGroup var2 = this.group;
      if (var2 != null) {
         var2.setCurrent((Checkbox)null);
      }

      this.group = var1;
      CheckboxPeer var3 = (CheckboxPeer)super.peer;
      if (var3 != null) {
         var3.setCheckboxGroup(var1);
      }

   }

   protected String paramString() {
      String var1 = super.paramString();
      String var2 = this.label;
      if (var2 != null) {
         var1 = var1 + ",label=" + var2;
      }

      return var1 + ",state=" + this.state;
   }
}
