package java.awt;

import java.awt.peer.ChoicePeer;
import java.util.Vector;

public class Choice extends Component {
   Vector pItems = new Vector();
   int selectedIndex = -1;

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Component)this).getToolkit().createChoice(this);
      }

      super.addNotify();
   }

   public int countItems() {
      return this.pItems.size();
   }

   public String getItem(int var1) {
      return (String)this.pItems.elementAt(var1);
   }

   public synchronized void addItem(String var1) {
      if (var1 == null) {
         throw new NullPointerException();
      } else {
         this.pItems.addElement(var1);
         ChoicePeer var2 = (ChoicePeer)super.peer;
         if (var2 != null) {
            var2.addItem(var1, this.pItems.size() - 1);
         }

         if (this.selectedIndex < 0) {
            this.select(0);
         }

      }
   }

   public String getSelectedItem() {
      int var1 = this.selectedIndex;
      return var1 >= 0 ? this.getItem(var1) : null;
   }

   public int getSelectedIndex() {
      return this.selectedIndex;
   }

   public synchronized void select(int var1) {
      if (var1 >= this.pItems.size()) {
         throw new IllegalArgumentException("illegal Choice item position: " + var1);
      } else {
         if (this.pItems.size() > 0) {
            this.selectedIndex = var1;
            ChoicePeer var2 = (ChoicePeer)super.peer;
            if (var2 != null) {
               var2.select(var1);
            }
         }

      }
   }

   public void select(String var1) {
      int var2 = this.pItems.indexOf(var1);
      if (var2 >= 0) {
         this.select(var2);
      }

   }

   protected String paramString() {
      return super.paramString() + ",current=" + this.getSelectedItem();
   }
}
