package java.awt;

import java.awt.peer.DialogPeer;

public class Dialog extends Window {
   boolean resizable;
   boolean modal;
   String title;

   public Dialog(Frame var1, boolean var2) {
      super(var1);
      this.resizable = true;
      this.modal = var2;
   }

   public Dialog(Frame var1, String var2, boolean var3) {
      this(var1, var3);
      this.title = var2;
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Window)this).getToolkit().createDialog(this);
      }

      super.addNotify();
   }

   public boolean isModal() {
      return this.modal;
   }

   public String getTitle() {
      return this.title;
   }

   public void setTitle(String var1) {
      this.title = var1;
      DialogPeer var2 = (DialogPeer)super.peer;
      if (var2 != null) {
         var2.setTitle(var1);
      }

   }

   public boolean isResizable() {
      return this.resizable;
   }

   public void setResizable(boolean var1) {
      this.resizable = var1;
      DialogPeer var2 = (DialogPeer)super.peer;
      if (var2 != null) {
         var2.setResizable(var1);
      }

   }

   protected String paramString() {
      String var1 = super.paramString() + (this.modal ? ",modal" : ",modeless");
      if (this.title != null) {
         var1 = var1 + ",title=" + this.title;
      }

      return var1;
   }
}
