package java.awt;

import java.awt.peer.FileDialogPeer;
import java.io.FilenameFilter;

public class FileDialog extends Dialog {
   public static final int LOAD = 0;
   public static final int SAVE = 1;
   int mode;
   String dir;
   String file;
   FilenameFilter filter;
   private static final String base = "filedlg";
   private static int nameCounter;
   private static final long serialVersionUID = 5035145889651310422L;

   public FileDialog(Frame var1) {
      this(var1, "", 0);
   }

   public FileDialog(Frame var1, String var2) {
      this(var1, var2, 0);
   }

   public FileDialog(Frame var1, String var2, int var3) {
      super(var1, var2, true);
      super.name = "filedlg" + nameCounter++;
      this.mode = var3;
      ((Container)this).setLayout((LayoutManager)null);
   }

   public void addNotify() {
      if (super.peer == null) {
         super.peer = ((Window)this).getToolkit().createFileDialog(this);
      }

      super.addNotify();
   }

   public int getMode() {
      return this.mode;
   }

   public void setMode(int var1) {
      switch (var1) {
         case 0:
         case 1:
            this.mode = var1;
            return;
         default:
            throw new IllegalArgumentException("illegal file dialog mode");
      }
   }

   public String getDirectory() {
      return this.dir;
   }

   public synchronized void setDirectory(String var1) {
      this.dir = var1;
      FileDialogPeer var2 = (FileDialogPeer)super.peer;
      if (var2 != null) {
         var2.setDirectory(var1);
      }

   }

   public String getFile() {
      return this.file;
   }

   public synchronized void setFile(String var1) {
      this.file = var1;
      FileDialogPeer var2 = (FileDialogPeer)super.peer;
      if (var2 != null) {
         var2.setFile(var1);
      }

   }

   public FilenameFilter getFilenameFilter() {
      return this.filter;
   }

   public synchronized void setFilenameFilter(FilenameFilter var1) {
      this.filter = var1;
      FileDialogPeer var2 = (FileDialogPeer)super.peer;
      if (var2 != null) {
         var2.setFilenameFilter(var1);
      }

   }

   protected String paramString() {
      String var1 = super.paramString();
      if (this.dir != null) {
         var1 = var1 + ",dir= " + this.dir;
      }

      return var1 + (this.mode == 0 ? ",load" : ",save");
   }

   boolean postsOldMouseEvents() {
      return false;
   }
}
