package java.awt;

import java.awt.peer.LabelPeer;

public class Label extends Component {
   public static final int LEFT = 0;
   public static final int CENTER = 1;
   public static final int RIGHT = 2;
   String label;
   int alignment;

   public Label() {
      this("");
   }

   public Label(String var1) {
      this.alignment = 0;
      this.label = var1;
   }

   public Label(String var1, int var2) {
      this.alignment = 0;
      this.label = var1;
      this.setAlignment(var2);
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Component)this).getToolkit().createLabel(this);
      }

      super.addNotify();
   }

   public int getAlignment() {
      return this.alignment;
   }

   public void setAlignment(int var1) {
      switch (var1) {
         case 0:
         case 1:
         case 2:
            this.alignment = var1;
            LabelPeer var2 = (LabelPeer)super.peer;
            if (var2 != null) {
               var2.setAlignment(var1);
            }

            return;
         default:
            throw new IllegalArgumentException("improper alignment: " + var1);
      }
   }

   public String getText() {
      return this.label;
   }

   public void setText(String var1) {
      if (var1 != this.label && (this.label == null || !this.label.equals(var1))) {
         this.label = var1;
         LabelPeer var2 = (LabelPeer)super.peer;
         if (var2 != null) {
            var2.setText(var1);
         }
      }

   }

   protected String paramString() {
      String var1 = ",align=";
      switch (this.alignment) {
         case 0:
            var1 = var1 + "left";
            break;
         case 1:
            var1 = var1 + "center";
            break;
         case 2:
            var1 = var1 + "right";
      }

      return super.paramString() + var1 + ",label=" + this.label;
   }
}
