package java.awt;

import java.awt.peer.MenuComponentPeer;
import java.io.Serializable;

public abstract class MenuComponent implements Serializable {
   transient MenuComponentPeer peer;
   transient MenuContainer parent;
   Font font;

   public MenuContainer getParent() {
      return this.parent;
   }

   public MenuComponentPeer getPeer() {
      return this.peer;
   }

   public Font getFont() {
      Font var1 = this.font;
      if (var1 != null) {
         return var1;
      } else {
         MenuContainer var2 = this.parent;
         return var2 != null ? var2.getFont() : null;
      }
   }

   public void setFont(Font var1) {
      this.font = var1;
   }

   public void removeNotify() {
      MenuComponentPeer var1 = this.peer;
      if (var1 != null) {
         var1.dispose();
         this.peer = null;
      }

   }

   public boolean postEvent(Event var1) {
      MenuContainer var2 = this.parent;
      if (var2 != null) {
         var2.postEvent(var1);
      }

      return false;
   }

   protected String paramString() {
      return "";
   }

   public String toString() {
      return this.getClass().getName() + "[" + this.paramString() + "]";
   }
}
