package java.awt;

import java.awt.peer.MenuItemPeer;

public class MenuItem extends MenuComponent {
   boolean enabled = true;
   String label;

   public MenuItem(String var1) {
      this.label = var1;
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = Toolkit.getDefaultToolkit().createMenuItem(this);
      }

   }

   public String getLabel() {
      return this.label;
   }

   public void setLabel(String var1) {
      this.label = var1;
      MenuItemPeer var2 = (MenuItemPeer)super.peer;
      if (var2 != null) {
         var2.setLabel(var1);
      }

   }

   public boolean isEnabled() {
      return this.enabled;
   }

   public void enable() {
      this.enabled = true;
      MenuItemPeer var1 = (MenuItemPeer)super.peer;
      if (var1 != null) {
         var1.enable();
      }

   }

   public void enable(boolean var1) {
      if (var1) {
         this.enable();
      } else {
         this.disable();
      }
   }

   public void disable() {
      this.enabled = false;
      MenuItemPeer var1 = (MenuItemPeer)super.peer;
      if (var1 != null) {
         var1.disable();
      }

   }

   public String paramString() {
      return "label=" + this.label;
   }
}
