package java.awt;

import java.awt.peer.TextAreaPeer;

public class TextArea extends TextComponent {
   int rows;
   int cols;

   public TextArea() {
      super("");
   }

   public TextArea(int var1, int var2) {
      super("");
      this.rows = var1;
      this.cols = var2;
   }

   public TextArea(String var1) {
      super(var1);
   }

   public TextArea(String var1, int var2, int var3) {
      super(var1);
      this.rows = var2;
      this.cols = var3;
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Component)this).getToolkit().createTextArea(this);
      }

      super.addNotify();
   }

   public void insertText(String var1, int var2) {
      TextAreaPeer var3 = (TextAreaPeer)super.peer;
      if (var3 != null) {
         var3.insertText(var1, var2);
      } else {
         super.text = super.text.substring(0, var2) + var1 + super.text.substring(var2);
      }
   }

   public void appendText(String var1) {
      if (super.peer != null) {
         this.insertText(var1, ((TextComponent)this).getText().length());
      } else {
         super.text = super.text + var1;
      }
   }

   public void replaceText(String var1, int var2, int var3) {
      TextAreaPeer var4 = (TextAreaPeer)super.peer;
      if (var4 != null) {
         var4.replaceText(var1, var2, var3);
      } else {
         super.text = super.text.substring(0, var2) + var1 + super.text.substring(var3);
      }
   }

   public int getRows() {
      return this.rows;
   }

   public int getColumns() {
      return this.cols;
   }

   public Dimension preferredSize(int var1, int var2) {
      TextAreaPeer var3 = (TextAreaPeer)super.peer;
      return var3 != null ? var3.preferredSize(var1, var2) : super.preferredSize();
   }

   public Dimension preferredSize() {
      return this.rows > 0 && this.cols > 0 ? this.preferredSize(this.rows, this.cols) : super.preferredSize();
   }

   public Dimension minimumSize(int var1, int var2) {
      TextAreaPeer var3 = (TextAreaPeer)super.peer;
      return var3 != null ? var3.minimumSize(var1, var2) : super.minimumSize();
   }

   public Dimension minimumSize() {
      return this.rows > 0 && this.cols > 0 ? this.minimumSize(this.rows, this.cols) : super.minimumSize();
   }

   protected String paramString() {
      return super.paramString() + ",rows=" + this.rows + ",cols=" + this.cols;
   }
}
