package java.awt;

import java.awt.peer.TextComponentPeer;

public class TextComponent extends Component {
   String text;
   boolean editable = true;
   int selStart;
   int selEnd;

   TextComponent(String var1) {
      this.text = var1;
   }

   public synchronized void removeNotify() {
      TextComponentPeer var1 = (TextComponentPeer)super.peer;
      if (var1 != null) {
         this.text = var1.getText();
         this.selStart = var1.getSelectionStart();
         this.selEnd = var1.getSelectionEnd();
      }

      super.removeNotify();
   }

   public void setText(String var1) {
      this.text = var1;
      TextComponentPeer var2 = (TextComponentPeer)super.peer;
      if (var2 != null) {
         var2.setText(var1);
      }

   }

   public String getText() {
      TextComponentPeer var1 = (TextComponentPeer)super.peer;
      if (var1 != null) {
         this.text = var1.getText();
      }

      return this.text;
   }

   public String getSelectedText() {
      return this.getText().substring(this.getSelectionStart(), this.getSelectionEnd());
   }

   public boolean isEditable() {
      return this.editable;
   }

   public void setEditable(boolean var1) {
      this.editable = var1;
      TextComponentPeer var2 = (TextComponentPeer)super.peer;
      if (var2 != null) {
         var2.setEditable(var1);
      }

   }

   public int getSelectionStart() {
      TextComponentPeer var1 = (TextComponentPeer)super.peer;
      if (var1 != null) {
         this.selStart = var1.getSelectionStart();
      }

      return this.selStart;
   }

   public int getSelectionEnd() {
      TextComponentPeer var1 = (TextComponentPeer)super.peer;
      if (var1 != null) {
         this.selEnd = var1.getSelectionEnd();
      }

      return this.selEnd;
   }

   public void select(int var1, int var2) {
      String var3 = this.getText();
      if (var1 < 0) {
         var1 = 0;
      }

      if (var2 > var3.length()) {
         var2 = var3.length();
      }

      if (var2 < var1) {
         var2 = var1;
      }

      if (var1 > var2) {
         var1 = var2;
      }

      this.selStart = var1;
      this.selEnd = var2;
      TextComponentPeer var4 = (TextComponentPeer)super.peer;
      if (var4 != null) {
         var4.select(var1, var2);
      }

   }

   public void selectAll() {
      this.getText();
      this.selStart = 0;
      this.selEnd = this.getText().length();
      TextComponentPeer var1 = (TextComponentPeer)super.peer;
      if (var1 != null) {
         var1.select(this.selStart, this.selEnd);
      }

   }

   protected String paramString() {
      String var1 = super.paramString() + ",text=" + this.getText();
      if (this.editable) {
         var1 = var1 + ",editable";
      }

      return var1 + ",selection=" + this.getSelectionStart() + "-" + this.getSelectionEnd();
   }
}
