package java.awt;

import java.awt.peer.TextFieldPeer;

public class TextField extends TextComponent {
   int cols;
   char echoChar;

   public TextField() {
      super("");
   }

   public TextField(int var1) {
      super("");
      this.cols = var1;
   }

   public TextField(String var1) {
      super(var1);
   }

   public TextField(String var1, int var2) {
      super(var1);
      this.cols = var2;
   }

   public synchronized void addNotify() {
      if (super.peer == null) {
         super.peer = ((Component)this).getToolkit().createTextField(this);
      }

      super.addNotify();
   }

   public char getEchoChar() {
      return this.echoChar;
   }

   public boolean echoCharIsSet() {
      return this.echoChar != 0;
   }

   public int getColumns() {
      return this.cols;
   }

   public void setEchoCharacter(char var1) {
      this.echoChar = var1;
      TextFieldPeer var2 = (TextFieldPeer)super.peer;
      if (var2 != null) {
         var2.setEchoCharacter(var1);
      }

   }

   public Dimension preferredSize(int var1) {
      TextFieldPeer var2 = (TextFieldPeer)super.peer;
      return var2 != null ? var2.preferredSize(var1) : super.preferredSize();
   }

   public Dimension preferredSize() {
      return this.cols > 0 ? this.preferredSize(this.cols) : super.preferredSize();
   }

   public Dimension minimumSize(int var1) {
      TextFieldPeer var2 = (TextFieldPeer)super.peer;
      return var2 != null ? var2.minimumSize(var1) : super.minimumSize();
   }

   public Dimension minimumSize() {
      return this.cols > 0 ? this.minimumSize(this.cols) : super.minimumSize();
   }

   protected String paramString() {
      String var1 = super.paramString();
      if (this.echoChar != 0) {
         var1 = var1 + ",echo=" + this.echoChar;
      }

      return var1;
   }
}
